/* list_rchan.h: a definition of a Reformatter Channel List struct */

/*
 * @(#) $Header: /cs/research/pp/hubris/pp-beta/h/RCS/list_rchan.h,v 5.0 90/09/20 16:50:26 pp Exp Locker: pp $
 *
 * $Log:	list_rchan.h,v $
 * Revision 5.0  90/09/20  16:50:26  pp
 * rcsforce : 5.0 public release
 * 
 *
 */



#ifndef _H_LIST_RCHAN
#define _H_LIST_RCHAN

#include "chan.h"
#include "auth.h"

/*
li_mta  - is the remote site/mta e.g "stl.stc.co.uk" or "DLCMHS" etc
li_chan - is the channel pointer for that site e.g "PSS" "x400out84" etc


Note:
	That though this list structure is used both for the reformatting
	and the outgoing channels, Only the outgoing channels have the
	li_name array set.
*/

typedef struct list_rchan {
	char                    *li_mta;
	CHAN                    *li_chan;
	AUTH                    *li_auth;
	struct list_rchan       *li_next;
} LIST_RCHAN;

#define NULLIST_RCHAN           ((LIST_RCHAN *)0)

extern  LIST_RCHAN              *list_rchan_new();
extern  LIST_RCHAN              *list_rchan_malloc();
extern	void			list_rchan_free ();
extern	int			list_rchan_ssite ();
extern	int			list_rchan_schan ();
extern	void			list_rchan_add ();
#endif
